#include <iostream>
#include <string>
#include <algorithm>
#include <vector>

using namespace std;

string lunaSum(const string& a, const string& b) {
	string result = "";
	int i = a.length() - 1, j = b.length() - 1;
	while (i >= 0 || j >= 0) {
		int digitA = (i >= 0) ? a[i] - '0' : 0;
		int digitB = (j >= 0) ? b[j] - '0' : 0;
		result = to_string(max(digitA, digitB)) + result;
		i--;
		j--;
	}
	return result;
}

string lunaProduct(const string& a, const string& b) {
	string result = "";
	int lenA = a.length();
	int lenB = b.length();
	vector<long long> intermediateResult(lenA + lenB, 0);

	for (int i = 0; i < lenA; ++i) {
		for (int j = 0; j < lenB; ++j) {
			intermediateResult[i + j] += min(a[lenA - 1 - i] - '0', b[lenB - 1 - j] - '0');
		}
	}

	for (int i = 0; i < intermediateResult.size() - 1; ++i) {
		intermediateResult[i + 1] += intermediateResult[i] / 10;
		intermediateResult[i] %= 10;
	}

	for (int i = intermediateResult.size() - 1; i >= 0; --i) {
		result += to_string(intermediateResult[i]);
	}

	size_t firstDigit = result.find_first_not_of('0');
	if (firstDigit == string::npos) return "0";
	return result.substr(firstDigit);

}

int main() {
	string a, b;
	cin >> a >> b;
	cout << lunaSum(a, b) << " " << lunaProduct(a, b) << endl;
	return 0;
}