#include <iostream>
#include <string>
#include <algorithm>
#include <vector>

using namespace std;

pair<string, string> lunarArithmetic(const string& a, const string& b) {
	size_t lenA = a.size();
	size_t lenB = b.size();
	size_t maxLen = max(lenA, lenB);

	vector<char> sumArray(maxLen, '0');
	vector<char> productArray(maxLen + 1, '0');

	for (size_t i = 0; i < maxLen; ++i) {
		char digitA = (i < lenA) ? a[lenA - 1 - i] : '0';
		char digitB = (i < lenB) ? b[lenB - 1 - i] : '0';
		sumArray[maxLen - 1 - i] = max(digitA, digitB);
	}

	for (size_t i = 0; i < lenA; ++i) {
		for (size_t j = 0; j < lenB; ++j) {
			char digitA = a[lenA - 1 - i];
			char digitB = b[lenB - 1 - j];
			char productDigit = min(digitA, digitB);
			productArray[maxLen - 1 - i - j] = (productArray[maxLen - 1 - i - j] == '0')
				? productDigit
				: min(productArray[maxLen - 1 - i - j], productDigit);
		}
	}

	size_t startIndex = 0;
	while (startIndex < productArray.size() - 1 && productArray[startIndex] == '0') {
		startIndex++;
	}

	string sumResult(sumArray.begin(), sumArray.end());
	string productResult(productArray.begin() + startIndex, productArray.end());

	return{ sumResult, productResult };
}

int main() {
	string a, b;
	cin >> a >> b;

	auto[sum, product] = lunarArithmetic(a, b);
	cout << sum << " " << product << endl;


	return 0;
}