#include <iostream>
#include <string>
#include <algorithm>
#include <vector>

using namespace std;

string lunarAdd(const string& a, const string& b) {
	int len = max(a.length(), b.length());
	string paddedA = string(len - a.length(), '0') + a;
	string paddedB = string(len - b.length(), '0') + b;
	string result = "";
	for (int i = 0; i < len; ++i) {
		result += to_string(max(paddedA[i] - '0', paddedB[i] - '0'));
	}
	return result;
}

string lunarMultiply(const string& a, const string& b) {
	int lenA = a.length();
	int lenB = b.length();
	vector<long long> intermediateResult(lenA + lenB - 1, 0);

	for (int i = 0; i < lenA; ++i) {
		for (int j = 0; j < lenB; ++j) {
			intermediateResult[i + j] += min(a[lenA - 1 - i] - '0', b[lenB - 1 - j] - '0');
		}
	}

	for (int i = 0; i < intermediateResult.size() - 1; ++i) {
		intermediateResult[i + 1] += intermediateResult[i] / 10;
		intermediateResult[i] %= 10;
	}

	string result = to_string(intermediateResult.back());
	for (int i = intermediateResult.size() - 2; i >= 0; --i) {
		result = to_string(intermediateResult[i]) + result;
	}
	return result;
}

int main() {
	string a, b;
	cin >> a >> b;
	cout << lunarAdd(a, b) << " " << lunarMultiply(a, b) << endl;
	return 0;
}