#include <iostream>
#include <string>
#include <algorithm>

std::string lunaSum(const std::string& a, const std::string& b) {
	std::string result;
	int lengthA = a.size();
	int lengthB = b.size();
	int maxLength = std::max(lengthA, lengthB);
	std::string aPadded = std::string(maxLength - lengthA, '0') + a;
	std::string bPadded = std::string(maxLength - lengthB, '0') + b;
	for (int i = 0; i < maxLength; ++i) {
		result += std::max(aPadded[i], bPadded[i]);
	}
	return result;
}

std::string lunaProduct(const std::string& a, const std::string& b) {
	std::string result;
	int lengthA = a.size();
	int lengthB = b.size();
	std::string aPadded = std::string(lengthB, '0') + a;
	std::string bPadded = std::string(lengthA, '0') + b;
	for (int i = 0; i < std::max(lengthA, lengthB); ++i) {
		result += std::min(aPadded[i], bPadded[i]);
	}
	while (result.size() > 1 && result[0] == '0') {
		result.erase(result.begin());
	}
	return result;
}

int main() {
	std::string a, b;
	std::cin >> a >> b;
	std::string sum = lunaSum(a, b);
	std::string product = lunaProduct(a, b);
	std::cout << sum << "\n" << product << std::endl;
	return 0;
}