#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>

using namespace std;

int main() {
	int n, m, k;
	cin >> n >> m >> k;

	vector<tuple<int, int>> edges;
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		edges.emplace_back(u, v);
	}

	vector<pair<int, int>> guards(k);
	for (int i = 0; i < k; ++i) {
		cin >> guards[i].first >> guards[i].second;
	}

	vector<bool> protected_warehouses(n + 1, false);
	for (int i = 0; i < k; ++i) {
		int guard_warehouse = guards[i].first;
		int guard_range = guards[i].second;

		queue<pair<int, int>> q;
		q.push({ guard_warehouse, 0 });
		vector<bool> visited(n + 1, false);
		visited[guard_warehouse] = true;

		while (!q.empty()) {
			int u = q.front().first;
			int dist = q.front().second;
			q.pop();

			if (dist <= guard_range) {
				protected_warehouses[u] = true;
			}
			if (dist >= guard_range) continue;

			for (const auto& edge : edges) {
				int v = -1;
				if (get<0>(edge) == u) v = get<1>(edge);
				if (get<1>(edge) == u) v = get<0>(edge);
				if (v != -1 && !visited[v]) {
					visited[v] = true;
					q.push({ v, dist + 1 });
				}
			}
		}
	}

	vector<int> result;
	for (int i = 1; i <= n; ++i) {
		if (protected_warehouses[i]) {
			result.push_back(i);
		}
	}

	cout << result.size() << endl;
	if (!result.empty()) {
		for (int i = 0; i < result.size(); ++i) {
			cout << result[i] << (i == result.size() - 1 ? "" : " ");
		}
		cout << endl;
	}

	return 0;
}