#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <algorithm>

using namespace std;

int main() {
	int n, m, k;
	cin >> n >> m >> k;

	vector<vector<int>> graph(n + 1);
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		graph[u].push_back(v);
		graph[v].push_back(u);
	}

	vector<pair<int, int>> guards(k);
	for (int i = 0; i < k; ++i) {
		cin >> guards[i].first >> guards[i].second;
	}

	set<int> protectedWarehouses;
	for (const auto& guard : guards) {
		int start = guard.first;
		int stamina = guard.second;

		vector<int> dist(n + 1, -1);
		dist[start] = 0;
		queue<int> q;
		q.push(start);

		while (!q.empty()) {
			int u = q.front();
			q.pop();

			for (int v : graph[u]) {
				if (dist[v] == -1) {
					dist[v] = dist[u] + 1;
					if (dist[v] <= stamina) {
						protectedWarehouses.insert(v);
						q.push(v);
					}
				}
			}
		}
	}

	vector<int> result(protectedWarehouses.begin(), protectedWarehouses.end());
	sort(result.begin(), result.end());

	cout << result.size() << endl;
	if (!result.empty()) {
		for (int i = 0; i < result.size(); ++i) {
			cout << result[i] << (i == result.size() - 1 ? "" : " ");
		}
		cout << endl;
	}
	
	return 0;
}