#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <algorithm>

using namespace std;

int main() {
	int n, m, k;
	cin >> n >> m >> k;
	vector<vector<int>> graph(n + 1);
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		graph[a].push_back(b);
		graph[b].push_back(a);
	}
	vector<pair<int, int>> guards(k);
	for (int i = 0; i < k; ++i) {
		cin >> guards[i].first >> guards[i].second;
	}
	set<int> guarded;
	for (const auto& guard : guards) {
		int start = guard.first;
		int stamina = guard.second;
		vector<bool> visited(n + 1, false);
		queue<pair<int, int>> q;
		q.push({ start, 0 });
		visited[start] = true;
		while (!q.empty()) {
			auto[current, dist] = q.front();
			q.pop();
			guarded.insert(current);
			if (dist < stamina) {
				for (int neighbor : graph[current]) {
					if (!visited[neighbor]) {
						visited[neighbor] = true;
						q.push({ neighbor, dist + 1 });
					}
				}
			}
		}
	}
	cout << guarded.size() << endl;
	if (!guarded.empty()) {
		vector<int> result(guarded.begin(), guarded.end());
		sort(result.begin(), result.end());
		for (int v : result) {
			cout << v << " ";
		}
		cout << endl;
	}
	else {
		cout << endl;
	}
	return 0;
}