#include <iostream>
#include <vector>
#include <cmath>
#include <limits>
#include <iomanip>

using namespace std;

double calculateDistance(pair<int, int> a, pair<int, int> b) {
	return abs(a.first - b.first) + abs(a.second - b.second);
}

int main() {
	int n;
	cin >> n;
	vector<pair<int, int>> points(n);
	for (int i = 0; i < n; ++i) {
		cin >> points[i].first >> points[i].second;
	}
	vector<vector<double>> dist(n, vector<double>(n));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (i != j) {
				dist[i][j] = calculateDistance(points[i], points[j]);
			}
		}
	}
	const int MAX_MASK = (1 << n);
	vector<vector<double>> dp(MAX_MASK, vector<double>(n, numeric_limits<double>::infinity()));
	dp[1][0] = 0;
	for (int mask = 1; mask < MAX_MASK; ++mask) {
		for (int last = 0; last < n; ++last) {
			if (!(mask & (1 << last))) continue;
			for (int next = 0; next < n; ++next) {
				if (next != last && (mask & (1 << next)) == 0) {
					int nextMask = mask | (1 << next);
					dp[nextMask][next] = min(dp[nextMask][next], dp[mask][last] + dist[last][next]);
				}
			}
		}
	}
	double minPath = numeric_limits<double>::infinity();
	for (int last = 1; last < n; ++last) {
		minPath = min(minPath, dp[MAX_MASK - 1][last] + dist[last][0]);
	}
	cout << fixed << setprecision(6) << minPath << endl;
	return 0;
}